chat/urls.py
# chat/urls.py
from django.urls import path

from . import views

urlpatterns = [
    path('', views.index, name='index'),
    path('<str:room_name>/', views.room, name='room'),
]

dashboard/urls.py
from django.urls import path
from . import views

app_name = 'dashboard'
urlpatterns = [
    path('', views.index,name="index"),
    path('logins/<int:user_id>', views.logins,name="logins"),
    path('homepage/<int:user_id>', views.homepage,name="homepage"),
]

miniproject1/urls.py
from django.contrib import admin
from django.urls import path, include
from register import views as v

urlpatterns = [
    path('admin/', admin.site.urls),
    path('register/',v.register,name="register" ),
    path('chat/', include('chat.urls')),
    path('', include("dashboard.urls")),
    path('',include('django.contrib.auth.urls')),
]

chat/models.py
from django.db import models

# Create your models here.

dashboard/models.py
import datetime
from django.db import models
from django.utils import timezone

# Create your models here.
class User(models.Model):
    user_text = models.CharField(max_length=200)
    password = models.CharField(max_length=200)
    def __str__(self):
        return self.user_text

class Message(models.Model):
    user = models.ForeignKey(User, on_delete=models.CASCADE)
    message_text = models.CharField(max_length=200)
    pub_date = models.DateTimeField('date published')
    def __str__(self):
        return self.message_text
    def was_published_recently(self):
        return self.pub_date >= timezone.now() - datetime.timedelta(days=1)

class Comment(models.Model):
    message = models.ForeignKey(Message, on_delete=models.CASCADE)
    comment_text = models.CharField(max_length=200)
    def __str__(self):
        return self.comment_text

register/models.py
from django.db import models

# Create your models here.

dashboard/forms.py
from django import forms

class CreateNewComment(forms.Form):
    comment = forms.CharField(label="comment", max_length=200)

class CreateNewMessage(forms.Form):
    message = forms.CharField(label="comment", max_length=200)

chat/views.py
from django.shortcuts import render

# Create your views here.
def index(request):
    return render(request, 'chat/index.html')

def room(request, room_name):
    return render(request, 'chat/room.html', {
        'room_name': room_name
    })

dashboard/views.py
from django.shortcuts import render,get_object_or_404
from django.http import HttpResponse, HttpResponseRedirect
from .models import User, Message, Comment
from .forms import CreateNewComment, CreateNewMessage
from django.contrib.auth.models import User as User2
from django.utils import timezone
# Create your views here.

def index(response):
    if response.method == "POST":
        print(response.POST)
        txt = response.POST.get("user")
        print(txt)
        user = response.POST.get("user")
        password = response.POST.get("password")
        c = User(user_text=user,password=password)
        c.save()
    all_users= User2.objects.all()
    latest_user_list = User.objects.all()
    context = {'latest_user_list': latest_user_list,'allusers': all_users}
    return render(response, 'dashboard/index.html', context)

def logins(response,user_id):
    if response.method == "POST":
        print(response.POST)
        txt = response.POST.get("user")
        print(txt)
        user = response.POST.get("user")
        password = response.POST.get("password")
        pw = User.objects.get(pk=user_id)
        if password == pw.password:
            return HttpResponseRedirect(reverse('dashboard:homepage', args=(user_id,)))
        
    latest_user_list = User.objects.all()
    context = {'latest_user_list': latest_user_list}
    return render(response, 'dashboard/logins.html', context)


def homepage(response,user_id):
    user = get_object_or_404(User, pk=user_id) 
    if response.method == "POST":
        print(response.POST)
        txt = response.POST.get("comment")
        print(txt)
        form = CreateNewComment(response.POST)
        if form.is_valid():
            Id = response.POST.get("Id")
            n = form.cleaned_data["comment"]
            c = Comment(comment_text=n,message_id=Id)
            c.save()
        else:
            Id = user_id
            n = response.POST.get("message")
            c = Message(message_text=n,user_id=Id,pub_date=timezone.now())
            c.save()
    else:
        form = CreateNewComment()
        
    return render(response, 'dashboard/homepage.html', {'user': user,'form':form})   

register/views.py
from django.shortcuts import render, redirect
from django.contrib.auth import login, authenticate
from django.contrib.auth.forms import UserCreationForm

# Create your views here.
def register(response):
    if response.method == "POST":
        form = UserCreationForm(response.POST)
        if form.is_valid():
            form.save()

            return redirect("/")
        else:
            form = UserCreationForm()
    form = UserCreationForm()
    return render(response, "register/register.html", {"form":form})

chat/templates/chat/index.html
<!-- chat/templates/chat/index.html -->
<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8"/>
    <title>Chat Rooms</title>
</head>
<body>
    What chat room would you like to enter?<br>
    <input id="room-name-input" type="text" size="100"><br>
    <input id="room-name-submit" type="button" value="Enter">

    <script>
        document.querySelector('#room-name-input').focus();
        document.querySelector('#room-name-input').onkeyup = function(e) {
            if (e.keyCode === 13) {  // enter, return
                document.querySelector('#room-name-submit').click();
            }
        };

        document.querySelector('#room-name-submit').onclick = function(e) {
            var roomName = document.querySelector('#room-name-input').value;
            window.location.pathname = '/chat/' + roomName + '/';
        };
    </script>
</body>
</html>

chat/templates/chat/room.html
<!-- chat/templates/chat/room.html -->
<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8"/>
    <title>Chat Room</title>
</head>
<body>
    <textarea id="chat-log" cols="100" rows="20"></textarea><br>
    <input id="chat-message-input" type="text" size="100"><br>
    <input id="chat-message-submit" type="button" value="Send">
    {{ room_name|json_script:"room-name" }}
    <script>
        const roomName = JSON.parse(document.getElementById('room-name').textContent);

        const chatSocket = new WebSocket(
            'ws://'
            + window.location.host
            + '/ws/chat/'
            + roomName
            + '/'
        );

        chatSocket.onmessage = function(e) {
            const data = JSON.parse(e.data);
            document.querySelector('#chat-log').value += (data.message + '\n');
        };

        chatSocket.onclose = function(e) {
            console.error('Chat socket closed unexpectedly');
        };

        document.querySelector('#chat-message-input').focus();
        document.querySelector('#chat-message-input').onkeyup = function(e) {
            if (e.keyCode === 13) {  // enter, return
                document.querySelector('#chat-message-submit').click();
            }
        };

        document.querySelector('#chat-message-submit').onclick = function(e) {
            const messageInputDom = document.querySelector('#chat-message-input');
            const message = messageInputDom.value;
            chatSocket.send(JSON.stringify({
                'message': message
            }));
            messageInputDom.value = '';
        };
    </script>
</body>
</html>

dashboard/templates/dashboard/homepage.html
<h1>{{ user.user_text }}</h1>
<form method="post" action="#">
    {% csrf_token %}
    <input type="text" name="message">
    <input type="hidden" name="msgid" value={{ user.id }}>
    <button type="submit" name="newmsg">New Message</button>
</form>
<ul>
{% for message in user.message_set.all %}
    <li>{{ message.message_text }}</li>
    <form method="post" action="#">
        {% csrf_token %}
        {{form}}
        <input type="hidden" name="Id" value={{ message.id }}>
        <button type="submit" name="newcmt">New Comment</button>
    </form>
    {% for comment in message.comment_set.all %}
        <dt>{{ comment.comment_text }}</dt>
    {% endfor %}
    </br>
{% endfor %}
</ul>

dashboard/templates/dashboard/index.html
{% if user.is_authenticated %}
    {% if latest_user_list %}
        <ul>
        {% for user in latest_user_list %}
            <li><a href={% url 'dashboard:homepage' user.id %}>{{ user.user_text }}</a></li>
        {% endfor %}<br>
        <br>
        <ul>
            {% for user in all_users %}
                <li><a href={% url 'dashboard:homepage' user.id %}>{{ user.user_text }}</a></li>
            {% endfor %}<br>
        <br>
    {% else %}
        <p>No user are available.</p>
    {% endif %}
    <form method="post" action="#">
        {% csrf_token %}
        <label>Insert New User:</label><br>
        <input type="text" name="user"><br>
        <label>Password:</label><br>
        <input type="text" name="password">
        <button type="submit" name="newuser">New User</button>
    </form>
{% endif %}
<a href="/login">login</a>

dashboard/templates/dashboard/logins.html
{% if user.is_authenticated %}
{% block content %}
login user
{% endblock %}
    <form method="post" action="{% url 'dashboard:homepage' user.id %}">
        {% csrf_token %}
        <label>Insert Username:</label><br>
        <input type="text" name="user"><br>
        <label>Password:</label><br>
        <input type="text" name="password">
        <button type="submit" name="log">Login</button>
    </form>
{% endif %}
<a href="/login">login</a>

register/templates/register/register.html
{% block title %}Create User{% endblock %}
{% load crispy_forms_tags %}

{% block content %}
    <form method="post" class="form-group">
        {% csrf_token %}
        {{form|crispy}}
        <button type="submit">register</button>
    </form>
{% endblock %}